Submit | All submissions | Best solutions | Back to list |
ROBOTGRI - Robots on a grid |
You have recently made a grid traversing robot that can find its way from the top left corner of a grid to the bottom right corner. However, you had forgotten all your AI programming skills, so you only programmed your robot to go rightwards and downwards (that's after all where the goal is). You have placed your robot on a grid with some obstacles, and you sit and observe. However, after a while you get tired of observing it getting stuck, and ask yourself "How many paths are there from the start position to the goal position?", and "If there are none, could the robot have made it to the goal if it could walk upwards and leftwards?" So you decide to write a program that, given a grid of size n x n with some obstacles marked on it where the robot cannot walk, counts the dierent ways the robot could go from the top left corner s to the bottom right t, and if none, tests if it were possible if it could walk up and left as well. However, your program does not handle very large numbers, so the answer should be given modulo 231 - 1.
Input
On the first line is one integer, 1 < n <= 1000. Then follows n lines, each with n characters, where each character is one of '.' and '#', where '.' is to be interpreted as a walkable tile and '#' as a non-walkable tile. There will never be a wall at s, and there will never be a wall at t.
Output
Output one line with the number of dierent paths starting in s and ending in t (modulo 231 - 1) or THE GAME IS A LIE if you cannot go from s to t going only rightwards and downwards but you can if you are allowed to go left and up as well, or INCONCEIVABLE if there simply is no path from s to t.
Example
Input: ..... #..#. #..#. ...#. ..... Output: 6
Added by: | Krzysztof Lewko |
Date: | 2011-10-05 |
Time limit: | 1s |
Source limit: | 50000B |
Memory limit: | 1536MB |
Cluster: | Cube (Intel G860) |
Languages: | All except: ASM64 |
Resource: | Nordic programming contest |
hide comments
|
|||||||
2019-05-12 14:29:29
Damn the modulo just gave me a headache use (1ll<<31)-1 instead of ll(1<<31) - 1 and here "ll" == long long |
|||||||
2017-03-25 09:23:46
dfs tle .. bfs AC.. |
|||||||
2016-08-23 00:06:20
finally AC , recursively for count the path top-down , then bfs |
|||||||
2015-10-20 19:39:36 Shubham Garg
A very silly mistake costed me many wrong answers. Be careful what your function returns. |
|||||||
2015-10-18 21:34:50 Fz
comments will help you, its enough if you are satisfied with small test cases (but exhaustive) of yours. |
|||||||
2015-02-03 12:03:49 Gaurav Kumar
Lesson learnt no to recursive dfs. |
|||||||
2015-01-25 13:42:32 sahni
Do it iteratively...recursely wrong answer..inbuilt stack overflow |
|||||||
2014-08-03 18:13:11 Mohit Mehta
dont forget to watch ur submission testing till the end. I had to re-run them for that only. |
|||||||
2014-08-03 14:43:13 ||N0VICE||
finally AC:) |
|||||||
2014-07-25 13:52:16 Archit Jain
iteratively AC recursively TLE |